/*
 * This class was originally supplied in the demos for Java2. It has been
 * seperated from its original filename, MetalWorksPrefs.java.
 *
 * It is therefore copyrighted to Sun Microsystems.
 *
 * Modified by Daniel Thompson.
 * 19/01/98
 */

package uk.org.redfelineninja.awt;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.metal.*;

/**
 * The ColumnLayout lays out any number of components in one vertical column.
 */
public class ColumnLayout implements LayoutManager {

    int xInset = 5;
    int yInset = 5;
    int yGap = 2;

    public void addLayoutComponent(String s, Component c) {}

    public void layoutContainer(Container c) {
        Insets insets = c.getInsets();
        int height = yInset + insets.top;

        Component[] children = c.getComponents();

        // DRT added fixed width layout Jan 1999
        int maxWidth = 0;
        for (int i = 0; i < children.length; i++) {
            maxWidth = Math.max(children[i].getPreferredSize().width, maxWidth);
        }

        Dimension compSize = null;
        for (int i = 0; i < children.length; i++) {
            compSize = children[i].getPreferredSize();
            children[i].setSize(maxWidth, compSize.height);
            children[i].setLocation(xInset + insets.left, height);
            height += compSize.height + yGap;
        }

    }

    public Dimension minimumLayoutSize(Container c) {
        Insets insets = c.getInsets();
        int height = yInset + insets.top;
        int width = 0 + insets.left + insets.right;

        Component[] children = c.getComponents();
        Dimension compSize = null;
        for (int i = 0; i < children.length; i++) {
            compSize = children[i].getPreferredSize();
            height += compSize.height + yGap;
            width = Math.max(width, compSize.width + insets.left + insets.right + xInset * 2);
        }
        height += insets.bottom;
        return new Dimension(width, height);
    }

    public Dimension preferredLayoutSize(Container c) {
        return minimumLayoutSize(c);
    }

    public void removeLayoutComponent(Component c) {}

}
