package uk.org.redfelineninja.image;

import java.awt.*;
import java.util.*;

/**
 * This class is used to store Images until they are required.
 *
 * This is a useful tool in overcoming the difficulties of allowing a
 * program to run as both an applet and an application. This class
 * uses a static Hashtable internally and has a similar interface.
 */

public class ImageBank {
    private static Hashtable images = new Hashtable();

    public static void put(Object key, Image pic) {
        images.put(key, pic);
    } // put

    public static Image get(Object key) {
        return (Image) images.get(key);
    } // get

    public static int size() {
        return images.size();
    } // size

    public static boolean isEmpty() {
        return images.isEmpty();
    } // isEmpty

    public static Enumeration elements() {
        return images.elements();
    } // elements

    public static boolean containsKey(Object key) {
        return images.containsKey(key);
    } // containsKey

    public static Image remove(Object key) {
        return (Image) images.remove(key);
    } // remove

    public static void clear() {
        images.clear();
    }

    /**
     * This would be called toString were the class not wholey static.
     */
    public static String string() {
        return images.toString();
    } // toString
} // class
