// RiskCardFrame.java

package uk.org.redfelineninja.risk.client;

import uk.org.redfelineninja.risk.data.*;
import uk.org.redfelineninja.risk.net.*;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;

/**
 * This is currently a test stub class for when cards are fully implemented.
 */
public class RiskCardFrame extends JFrame implements ActionListener {
    JPanel container;
    Card[] cards;

    public RiskCardFrame() {
        container = new JPanel();
        container.setLayout(new BorderLayout());

        // CARDS

        setCards(null);

        // BUTTONS

        JPanel buttons = new JPanel();
        buttons.setLayout(new FlowLayout(FlowLayout.CENTER));

        JButton b;

        // exchange button
        b = new JButton(Words.Exchange);
        buttons.add(b);
        b.addActionListener(this);

        // close button
        b = new JButton(Words.Close);
        buttons.add(b);
        b.addActionListener(this);

        // MAIN FRAME
        container.add(buttons, BorderLayout.SOUTH);
        getContentPane().add(container);

        pack();
    }

    protected void doExchange() {
        // firaActionPerformed ???
    }

    public void setCards(Card[] c) {
        cards = c;

        JPanel cardsPanel = new JPanel();

        if (cards == null) {
            cardsPanel.setLayout(new BorderLayout());
            cardsPanel.add(new JLabel(Words.You_have_no_cards));
        } else {
            cardsPanel.setLayout(new GridLayout(cards.length, 1));
            for (int i = 0; i < cards.length; i++) {
                JCheckBox cb = new JCheckBox(cards[i].country);
                cardsPanel.add(cb);
            } // for
        } // if

        cardsPanel.setBorder(new TitledBorder(Words.Risk_Cards));
        container.add(cardsPanel, BorderLayout.CENTER);

        // DISPLAY MAINTAINANCE
        pack();
        repaint();
    }

    public Card[] getCards() {
        return cards;
    }

    /**
     * This implementation of ActionListener should only be used by this class.
     * If the supplied ActionEvent has an actionCommand that matches
     * Words.Exchange then the system will behave as though the Exchange button
     * had been pressed. In all other cases the RiskCardFrame will be hidden.
     */
    public void actionPerformed(ActionEvent e) {
        if (e.getActionCommand().equals(Words.Exchange)) {
            doExchange();
        } else {
            this.setVisible(false);
        } // if
    } // actionPerformed( ActionEvent )
} // RiskCardFrame.class
