// RiskTalkerFrame.java

package uk.org.redfelineninja.risk.client;

import uk.org.redfelineninja.awt.BasicTalker;
import java.awt.*;
import javax.swing.JFrame;

/**
 * This is an indepentent window that the talker can be contained within.
 */
public class RiskTalkerFrame extends JFrame {
    BasicTalker talker;

    /**
     * Create a new RiskTalkerFrame using a new BasicTalker.
     *
     * @see uk.ac.warwick.starfish.awt.BasicTalker
     */
    public RiskTalkerFrame() {
        this(new BasicTalker());
    }

    /**
     * Create a new RiskTalkerFrame using the supplied BasicTalker.
     *
     * @see uk.ac.warwick.starfish.awt.BasicTalker
     */
    RiskTalkerFrame(BasicTalker t) {
        super(Words.talkerTitle);

        talker = t;
        t.setBackground(this.getBackground());
        this.getContentPane().setLayout(new BorderLayout());
    }

    /**
     * Set the talker used in this Frame.
     */
    public void setTalker(BasicTalker t) {
        talker = t;
    }

    /**
     * Get the talker used in this Frame.
     */
    public BasicTalker getTalker() {
        return talker;
    }

    /**
     * Show or hide this frame. This removes the talker component from the frame
     * when it is hidden so that docking of the talker can be done safely.
     */
    public void setVisible(boolean b) {
        if (b) {
            this.getContentPane().add(talker, BorderLayout.CENTER);
            pack();
            setSize(640, 200);
            super.setVisible(b);
        } else {
            super.setVisible(b);
            this.getContentPane().remove(talker);
        }
    } // setVisible( boolean )
} // RiskTalkerFrame.class
