// Player.java

package uk.org.redfelineninja.risk.data;

import java.awt.Color;

/**
 * Data type to store information about a player.
 */
public class Player {
    public Player(String n, Color c, boolean p) {
        name = n;
        playing = p;
        color = c;
    }

    public Player(String n, int c, boolean p) {
        name = n;
        playing = p;
        // the bitwise OR forces a full alpha (trnsparancy) component
        color = new Color(c | 0xff000000);
    }

    /**
     * Players are treated as equals if they have the same name.
     */
    public boolean equals(Object obj) {
        if (obj instanceof Player) {
            Player p = (Player) obj;
            if (p.name.equals(name)) {
                return true;
            }
        }

        return false;
    }

    public String toString() {
        return name;
    }

    public final String name;
    public final Color color;
    public boolean playing;
} // class
