// StringVector.java

package uk.org.redfelineninja.risk.data;

/**
 * This class provides alternative fetch methods on a Vector that have String
 * return types and perform type safety operations. Objects that are not
 * Strings should not really be added to this Vector.
 *
 * @author Daniel Thompson, Feb 1999
 */
public class StringVector extends java.util.Vector {
    /**
     * Returns the component at the specified index as a String.
     */
    public final String stringAt(int index) {
        if (elementData[index] instanceof String) {
            return (String) elementData[index];
        } else {
            return null;
        }
    } // stringAt( int )

    /**
     * Copies the compenents of this vector to the specified array of Strings.
     * The array must be large enough to contains all the elements of this
     * Vector.
     */
    public final void copyInto(String[] array) {
        for (int i = 0; i < elementCount; i++) {
            if (elementData[i] instanceof String) {
                array[i] = (String) elementData[i];
            } else {
                array[i] = null;
            }
        } // for
    } // copyInto( String [] )
} // StringVector.class
